package oko.tm.gsm_socket;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.support.v7.app.ActionBarActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.app.Activity;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.telephony.SmsManager;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;
import android.content.SharedPreferences;
import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;



public class MainActivity extends ActionBarActivity {

    //---------------------- Выпадающий список смс-команд
    String Command_1="Уст. Т min для оповещения";
    String Command_2="Уст. Т max для оповещения";
    String Command_3="Уст. Т для режима НАГРЕВ";
    String Command_4="Уст. Т для режима ХОЛОД";
    String Command_5="ВЫКЛ режим термостатирования";
    String Command_6="Выполнить USSD-запрос";
    String Command_7="Общие настройки прибора";


    String SMS_Command_1="61";
    String SMS_Command_2="62";
    String SMS_Command_3="6*1";
    String SMS_Command_4="6*1";
    String SMS_Command_5="6*1";
    String SMS_Command_6="03";
    String SMS_Command_7="09";

    public int COMMAND_POSITION = 0;
//----------------------------------------------------------



    //----- для создания служебного лога
    private static final String TAG = "myLogs";

    // это будет именем файла настроек,данных
    public static final String APP_PREFERENCES = "gsm_socket_settings";
    // переменная для работы с файлом
    SharedPreferences mSettings;


    // настройки, подлежащие хранению
    public static final String APP_PREFERENCES_PHONE = "phone";
    public static final String APP_PREFERENCES_PASSWORD = "password";
    public static final String APP_PREFERENCES_QUERY = "query";
    public static final String APP_PREFERENCES_POWER = "power";
    public static final String APP_PREFERENCES_RELE = "rele";
    public static final String APP_PREFERENCES_GSM = "gsm";
    public static final String APP_PREFERENCES_MODE = "mode";
    public static final String APP_PREFERENCES_TEMPERATURE = "temperature";
    public static final String APP_PREFERENCES_TERMOSTAT = "termostat";
    public static final String APP_PREFERENCES_T_MIN = "T_min";
    public static final String APP_PREFERENCES_T_MAX = "T_max";
    public static final String APP_PREFERENCES_CHECK_BOX_QUERY = "checkBox_query";
    public static final String APP_PREFERENCES_IMAGE_VIEW_POWER = "imageView_power";
    public static final String APP_PREFERENCES_IMAGE_VIEW_RELE = "imageView_rele";
    public static final String APP_PREFERENCES_IMAGE_VIEW_GSM = "imageView_GSM";
    public static final String APP_PREFERENCES_IMAGE_VIEW_TERMO = "imageView_termo";

    // --- телефонный номер розетки
    public String PHONE_NUMBER = "";
    // --- пароль управления розеткой
    public String PASSWORD = "";

    //----- перевод сообщений от розетки на кирилицу
    public static final String S_220V_ON = "220V ON";
    public static final String EST = "ЕСТЬ";
    public static final String S_220V_OFF = "220V OFF";
    public static final String NET = "НЕТ";

    public static final String SMS_RELE_ON = "RELE ON";
    public static final String VKL = "ВКЛЮЧЕНА";
    public static final String SMS_RELE_OFF = "RELE OFF";
    public static final String VYKL = "ВЫКЛЮЧЕНА";

    public static final String GSM_LEVEL_HIGH = "VYSOKIJ";
    public static final String VYSOKIJ = "ВЫСОКИЙ";

    public static final String GSM_LEVEL_MEDIUN = "SREDNIJ";
    public static final String SREDNIJ = "СРЕДНИЙ";

    public static final String GSM_LEVEL_LOW = "NIZKIJ";
    public static final String NIZKIJ = "НИЗКИЙ";

    public static final String TERMO_NAGREV = "Termo: Nagrev";
    public static final String NAGREV = "ОБОГРЕВ";

    public static final String TERMO_HOLOD = "Termo: Ohlazhdenie";
    public static final String HOLOD = "ОХЛАЖДЕНИЕ";

    public static final String TERMO_MANUAL = "Termo: OFF";
    public static final String MANUAL = "РУЧНОЙ";

    public static final String TEMPERATURE = "T:";
    public static final String T_MIN = "min:";
    public static final String T_MAX = "max:";
    public static final String TERMOSTAT = "Tn:";

    public static final String PONIZHENIE_T = "Ponizhenie T";
    public static final String ponizhenie_t = "Понижение температуры";

    public static final String PREVYSHENIE_T = "Prevyshenie T";
    public static final String prevyshenie_t = "Превышение температуры";

    public static final String VOSSTANOVLENIE_T = "Vosstanovlenie T";
    public static final String vosstanovlenie_t = "Восстановление температуры";


    // --- элементы отображения и управления
    Button btn_send_command;
    CheckBox checkBox_query;
    TextView textView_query;
    TextView textView_power;
    TextView textView_rele;
    TextView textView_gsm;
    TextView textView_mode;
    TextView textView_temperature;
    TextView textView_termostat;
    TextView textView_T_min;
    TextView textView_T_max;

    EditText txtCommand;

    ImageButton imageButton_ON;
    ImageButton imageButton_OFF;
    ImageButton imageButton_Query;

    ImageView imageView_power_on;
    ImageView imageView_power_off;
    ImageView imageView_power_;
    ImageView imageView_rele_on;
    ImageView imageView_rele_off;
    ImageView imageView_rele_;
    ImageView imageView_GSM_high;
    ImageView imageView_GSM_medium;
    ImageView imageView_GSM_low;
    ImageView imageView_GSM_;
    ImageView imageView_termo_off;
    ImageView imageView_termo_heater;
    ImageView imageView_termo_cooler;
    ImageView imageView_termo_;

    String Enter_Phone_Password = "Введите телефонный номер GSM-розетки и пароль доступа к ней";
    String Enter_Phone = "Введите телефонный номер GSM-розетки";
    String Enter_Password = "Введите пароль доступа GSM-розетки";


    // ------- для sms command
    String ini_password = "1234";
    String Socket_on = "06";
    String Socket_off = "05";
    String Query = "02";
    String Command = "";

    // ---- надписи на главном окне
    String update_time = "Обновление: ";
    String state_220v = "Наличие 220В: ";
    String state_rele = "Нагрузка: ";
    String gsm_level = "Уровень GSM: ";
    String state_mode = "Режим работы: ";
    String temperature = "Температура: ";
    String termostat = "Термостатирование: ";
    String T_min = "Нижняя граница оповещения: ";
    String T_max = "Верхняя граница оповещения: ";


    /**
     * Called when the activity is first created.
     */
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        //
        Log.d(TAG, "Начало onCreate");

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);



        //----------- работа с файлом, содержащий настройки
        mSettings = getSharedPreferences(APP_PREFERENCES, Context.MODE_PRIVATE);
        txtCommand = (EditText) findViewById(R.id.txtCommand);
        btn_send_command= (Button) findViewById(R.id.btn_send_command);
        checkBox_query = (CheckBox) findViewById(R.id.checkBox_query);
        imageButton_ON = (ImageButton) findViewById(R.id.imageButton_ON);
        imageButton_OFF = (ImageButton) findViewById(R.id.imageButton_OFF);
        imageButton_Query = (ImageButton) findViewById(R.id.imageButton_Query);
        imageView_power_off = (ImageView) findViewById(R.id.imageView_power_off);
        imageView_power_on = (ImageView) findViewById(R.id.imageView_power_on);
        imageView_power_ = (ImageView) findViewById(R.id.imageView_power_);
        imageView_rele_off = (ImageView) findViewById(R.id.imageView_rele_off);
        imageView_rele_on = (ImageView) findViewById(R.id.imageView_rele_on);
        imageView_rele_ = (ImageView) findViewById(R.id.imageView_rele_);
        imageView_GSM_high = (ImageView) findViewById(R.id.imageView_GSM_high);
        imageView_GSM_medium = (ImageView) findViewById(R.id.imageView_GSM_medium);
        imageView_GSM_low = (ImageView) findViewById(R.id.imageView_GSM_low);
        imageView_GSM_ = (ImageView) findViewById(R.id.imageView_GSM_);
        imageView_termo_off = (ImageView) findViewById(R.id.imageView_termo_off);
        imageView_termo_heater = (ImageView) findViewById(R.id.imageView_termo_heater);
        imageView_termo_cooler = (ImageView) findViewById(R.id.imageView_termo_cooler);
        imageView_termo_ = (ImageView) findViewById(R.id.imageView_termo_);

        textView_query = (TextView) findViewById(R.id.textView_query);
        textView_power = (TextView) findViewById(R.id.textView_power);
        textView_rele = (TextView) findViewById(R.id.textView_rele);
        textView_gsm = (TextView) findViewById(R.id.textView_gsm);
        textView_mode = (TextView) findViewById(R.id.textView_mode);
        textView_temperature = (TextView) findViewById(R.id.textView_temperature);
        textView_termostat = (TextView) findViewById(R.id.textView_termostat);
        textView_T_min = (TextView) findViewById(R.id.textView_T_min);
        textView_T_max = (TextView) findViewById(R.id.textView_T_max);


        //------------- обратотка входящей смс от SmsReceiver
        Intent intent = getIntent();
        String message_text = intent.getStringExtra("message");
        String sender = intent.getStringExtra("sender");
        sms_anal(message_text,sender);
        //--------------------------------





//--------------------------- обработчик события нажатия кнопки
        imageButton_Query.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                //
                Log.d(TAG, "Нажата кнопка Query");
                try_sendSMS(Query);

            }
        });

//--------------------------- обработчик события нажатия кнопки
        imageButton_ON.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Log.d(TAG, "Нажата кнопка ON");
                if (checkBox_query.isChecked()) {
                    try_sendSMS(Socket_on + "," + Query);
                } else {
                    try_sendSMS(Socket_on);
                }

            }
        });
//-------------------------------------------


//--------------------------- обработчик события нажатия кнопки
        imageButton_OFF.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Log.d(TAG, "Нажата кнопка OFF");
                if (checkBox_query.isChecked()) {
                    try_sendSMS(Socket_off + "," + Query);
                } else {
                    try_sendSMS(Socket_off);
                }

            }
        });
//-------------------------------------------


//--------------------------- обработчик события нажатия кнопки
        checkBox_query.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                SharedPreferences.Editor editor = mSettings.edit();
                if (checkBox_query.isChecked()) {
                    editor.putString(APP_PREFERENCES_CHECK_BOX_QUERY,"check");
                } else {
                    editor.putString(APP_PREFERENCES_CHECK_BOX_QUERY,"uncheck");
                }
                editor.commit();
            }
        });
//-------------------------------------------


    }





    @Override
    protected void onResume() {
        // TODO Auto-generated method stub
        super.onResume();



        String temp;
        //-------------восстанавливаем сохраненные настройки, данные
        if (mSettings.contains(APP_PREFERENCES_PHONE)) {
            PHONE_NUMBER = mSettings.getString(APP_PREFERENCES_PHONE, "");
        }

        if (mSettings.contains(APP_PREFERENCES_PASSWORD)) {
            PASSWORD = mSettings.getString(APP_PREFERENCES_PASSWORD, ini_password);
        }

        if (mSettings.contains(APP_PREFERENCES_QUERY)) {
            textView_query.setText(mSettings.getString(APP_PREFERENCES_QUERY, update_time));
        }

        if (mSettings.contains(APP_PREFERENCES_POWER)) {
            textView_power.setText(mSettings.getString(APP_PREFERENCES_POWER, state_220v));
        }

        if (mSettings.contains(APP_PREFERENCES_RELE)) {
            textView_rele.setText(mSettings.getString(APP_PREFERENCES_RELE, state_rele));
        }

        if (mSettings.contains(APP_PREFERENCES_GSM)) {
            textView_gsm.setText(mSettings.getString(APP_PREFERENCES_GSM, gsm_level));
        }

        if (mSettings.contains(APP_PREFERENCES_MODE)) {
            textView_mode.setText(mSettings.getString(APP_PREFERENCES_MODE, state_mode));
        }
        if (mSettings.contains(APP_PREFERENCES_TEMPERATURE)) {
            textView_temperature.setText(mSettings.getString(APP_PREFERENCES_TEMPERATURE, temperature));
        }

        if (mSettings.contains(APP_PREFERENCES_TERMOSTAT)) {
            textView_termostat.setText(mSettings.getString(APP_PREFERENCES_TERMOSTAT, termostat));
        }

        if (mSettings.contains(APP_PREFERENCES_T_MIN)) {
            textView_T_min.setText(mSettings.getString(APP_PREFERENCES_T_MIN, T_min));
        }
        if (mSettings.contains(APP_PREFERENCES_T_MAX)) {
            textView_T_max.setText(mSettings.getString(APP_PREFERENCES_T_MAX, T_max));
        }


        if (mSettings.contains(APP_PREFERENCES_IMAGE_VIEW_POWER)) {
            temp = mSettings.getString(APP_PREFERENCES_IMAGE_VIEW_POWER, "imageView_power_");
            imageView_power_.setVisibility(View.INVISIBLE);
            if (temp.equals("imageView_power_on")) {
                imageView_power_on.setVisibility(View.VISIBLE);
                imageView_power_off.setVisibility(View.INVISIBLE);
            }
            if (temp.equals("imageView_power_off")) {
                imageView_power_off.setVisibility(View.VISIBLE);
                imageView_power_on.setVisibility(View.INVISIBLE);
            }

        }

        if (mSettings.contains(APP_PREFERENCES_IMAGE_VIEW_RELE)) {
            temp = mSettings.getString(APP_PREFERENCES_IMAGE_VIEW_RELE, "imageView_rele_");
            imageView_rele_.setVisibility(View.INVISIBLE);
            if (temp.equals("imageView_rele_on")) {
                imageView_rele_on.setVisibility(View.VISIBLE);
                imageView_rele_off.setVisibility(View.INVISIBLE);
            }
            if (temp.equals("imageView_rele_off")) {
                imageView_rele_off.setVisibility(View.VISIBLE);
                imageView_rele_on.setVisibility(View.INVISIBLE);
            }

        }


        if (mSettings.contains(APP_PREFERENCES_IMAGE_VIEW_GSM)) {
            temp = mSettings.getString(APP_PREFERENCES_IMAGE_VIEW_GSM, "imageView_GSM_");
            imageView_GSM_.setVisibility(View.INVISIBLE);

            if (temp.equals("imageView_GSM_high")) {
                imageView_GSM_high.setVisibility(View.VISIBLE);
                imageView_GSM_medium.setVisibility(View.INVISIBLE);
                imageView_GSM_low.setVisibility(View.INVISIBLE);
            }

            if (temp.equals("imageView_GSM_medium")) {
                imageView_GSM_high.setVisibility(View.INVISIBLE);
                imageView_GSM_medium.setVisibility(View.VISIBLE);
                imageView_GSM_low.setVisibility(View.INVISIBLE);
            }

            if (temp.equals("imageView_GSM_low")) {
                imageView_GSM_high.setVisibility(View.INVISIBLE);
                imageView_GSM_medium.setVisibility(View.INVISIBLE);
                imageView_GSM_low.setVisibility(View.VISIBLE);
            }


        }



        if (mSettings.contains(APP_PREFERENCES_IMAGE_VIEW_TERMO)) {
            temp = mSettings.getString(APP_PREFERENCES_IMAGE_VIEW_TERMO, "imageView_termo_");
            imageView_termo_.setVisibility(View.INVISIBLE);

            if (temp.equals("imageView_termo_heater")) {
                imageView_termo_off.setVisibility(View.INVISIBLE);
                imageView_termo_heater.setVisibility(View.VISIBLE);
                imageView_termo_cooler.setVisibility(View.INVISIBLE);
            }

            if (temp.equals("imageView_termo_cooler")) {
                imageView_termo_off.setVisibility(View.INVISIBLE);
                imageView_termo_heater.setVisibility(View.INVISIBLE);
                imageView_termo_cooler.setVisibility(View.VISIBLE);
            }

            if (temp.equals("imageView_termo_off")) {
                imageView_termo_off.setVisibility(View.VISIBLE);
                imageView_termo_heater.setVisibility(View.INVISIBLE);
                imageView_termo_cooler.setVisibility(View.INVISIBLE);
            }


        }

        if (mSettings.contains(APP_PREFERENCES_CHECK_BOX_QUERY)) {
            temp = mSettings.getString(APP_PREFERENCES_CHECK_BOX_QUERY, "check");
            checkBox_query.setChecked(false);
            if (temp.equals("check")) {
                checkBox_query.setChecked(true);
            }


        }




        //--------------------------------------------------------

        //--------------------------- выпадающий список смс-команд
        String[] data = {
                Command_1,
                Command_2,
                Command_3,
                Command_4,
                Command_5,
                Command_6,
                Command_7};


        // адаптер
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, data);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

        Spinner spinner = (Spinner) findViewById(R.id.spinner);
        spinner.setAdapter(adapter);
        // заголовок
        spinner.setPrompt("Список команд");
        // выделяем элемент
        spinner.setSelection(0);

        // устанавливаем обработчик нажатия
        spinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view,
                                       int position, long id) {
                // показываем позиция нажатого элемента
                //Toast.makeText(getBaseContext(), "Position = " + position, Toast.LENGTH_SHORT).show();
                COMMAND_POSITION=position;
                switch (COMMAND_POSITION) {
                    case 0:
                        txtCommand.setText("+5");
                        txtCommand.setVisibility(View.VISIBLE);
                        break;
                    case 1:
                        txtCommand.setText("+40");
                        txtCommand.setVisibility(View.VISIBLE);
                        break;
                    case 2:
                        txtCommand.setText("+22");
                        txtCommand.setVisibility(View.VISIBLE);
                        break;
                    case 3:
                        txtCommand.setText("+18");
                        txtCommand.setVisibility(View.VISIBLE);
                        break;
                    case 4:
                        txtCommand.setVisibility(View.INVISIBLE);
                        break;
                    case 5:
                        txtCommand.setText("*111#");
                        txtCommand.setVisibility(View.VISIBLE);
                        break;
                    case 6:
                        txtCommand.setVisibility(View.INVISIBLE);
                        break;
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });

        //--------------------------- обработчик события нажатия кнопки
        btn_send_command.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

                switch (COMMAND_POSITION)
                {
                    case 0:
                        Command=Form_T(txtCommand.getText().toString());
                        if (checkBox_query.isChecked()) {
                            try_sendSMS(SMS_Command_1 + Command +"," + Query);
                        } else {
                            try_sendSMS(SMS_Command_1 + Command);
                        }
                        break;
                    case 1:
                        Command=Form_T(txtCommand.getText().toString());
                        if (checkBox_query.isChecked()) {
                            try_sendSMS(SMS_Command_2 + Command + "," + Query);
                        } else {
                            try_sendSMS(SMS_Command_2 + Command);
                        }
                        break;
                    case 2:
                        Command=Form_T(txtCommand.getText().toString());
                        if (checkBox_query.isChecked()) {
                            try_sendSMS(SMS_Command_3 + Command + "," + Query);
                        } else {
                            try_sendSMS(SMS_Command_3 + Command);
                        }
                        break;
                    case 3:
                        Command=Form_T(txtCommand.getText().toString());
                        if (checkBox_query.isChecked()) {
                            try_sendSMS(SMS_Command_4 + Command + "X" + "," + Query);
                        } else {
                            try_sendSMS(SMS_Command_4 + Command + "X");
                        }
                        break;
                    case 4:
                        if (checkBox_query.isChecked()) {
                            try_sendSMS(SMS_Command_5 + "-99" + "," + Query);
                        } else {
                            try_sendSMS(SMS_Command_5 + "-99");
                        }
                        break;
                    case 5:
                        Command=txtCommand.getText().toString();
                        if (checkBox_query.isChecked()) {
                            try_sendSMS(SMS_Command_6 + Command);
                        } else {
                            try_sendSMS(SMS_Command_6 + Command);
                        }
                        break;
                    case 6:
                        if (checkBox_query.isChecked()) {
                            try_sendSMS(SMS_Command_7);
                        } else {
                            try_sendSMS(SMS_Command_7);
                        }
                        break;

                }

            }
        });
//-------------------------------------------------------



    }

    private void sms_anal(String message_text, String sender)
    {
        // --- анализируем входящую смс от GSM-розетки
        if (sender != null)
        {
            //-------------- System date
            StringBuilder msgDate = new StringBuilder("");
            Format formatter = new SimpleDateFormat("dd:MM:yyyy HH:mm:ss");
            msgDate.append(formatter.format(new Date()));

            //--------------------проверяем наличие статусной смс
            if (message_text.indexOf("GSM:") > -1) {
                //--- да, статусная - отображаем значения на элементах интерфейса
                textView_query.setText(update_time + msgDate);

                String imageView_power = "imageView_power_";
                if (message_text.indexOf(S_220V_ON) > -1) {
                    imageView_power = "imageView_power_on";
                    textView_power.setText(state_220v + EST);
                    imageView_power_on.setVisibility(View.VISIBLE);
                    imageView_power_off.setVisibility(View.INVISIBLE);
                    imageView_power_.setVisibility(View.INVISIBLE);
                }

                if (message_text.indexOf(S_220V_OFF) > -1) {
                    textView_power.setText(state_220v + NET);
                    imageView_power = "imageView_power_off";
                    imageView_power_off.setVisibility(View.VISIBLE);
                    imageView_power_on.setVisibility(View.INVISIBLE);
                    imageView_power_.setVisibility(View.INVISIBLE);
                }

                String imageView_rele = "imageView_rele_";
                if (message_text.indexOf(SMS_RELE_ON) > -1) {
                    textView_rele.setText(state_rele + VKL);
                    imageView_rele = "imageView_rele_on";
                    imageView_rele_on.setVisibility(View.VISIBLE);
                    imageView_rele_off.setVisibility(View.INVISIBLE);
                    imageView_rele_.setVisibility(View.INVISIBLE);

                }

                if (message_text.indexOf(SMS_RELE_OFF) > -1) {
                    textView_rele.setText(state_rele + VYKL);
                    imageView_rele = "imageView_rele_off";
                    imageView_rele_off.setVisibility(View.VISIBLE);
                    imageView_rele_on.setVisibility(View.INVISIBLE);
                    imageView_rele_.setVisibility(View.INVISIBLE);

                }

                String imageView_GSM = "imageView_GSM_";
                if (message_text.indexOf(GSM_LEVEL_HIGH) > -1) {
                    textView_gsm.setText(gsm_level + VYSOKIJ);
                    imageView_GSM = "imageView_GSM_high";
                    imageView_GSM_high.setVisibility(View.VISIBLE);
                    imageView_GSM_medium.setVisibility(View.INVISIBLE);
                    imageView_GSM_low.setVisibility(View.INVISIBLE);
                    imageView_GSM_.setVisibility(View.INVISIBLE);
                }

                if (message_text.indexOf(GSM_LEVEL_MEDIUN) > -1) {
                    textView_gsm.setText(gsm_level + SREDNIJ);
                    imageView_GSM = "imageView_GSM_medium";
                    imageView_GSM_high.setVisibility(View.INVISIBLE);
                    imageView_GSM_medium.setVisibility(View.VISIBLE);
                    imageView_GSM_low.setVisibility(View.INVISIBLE);
                    imageView_GSM_.setVisibility(View.INVISIBLE);
                }

                if (message_text.indexOf(GSM_LEVEL_LOW) > -1) {
                    textView_gsm.setText(gsm_level + NIZKIJ);
                    imageView_GSM = "imageView_GSM_low";
                    imageView_GSM_high.setVisibility(View.INVISIBLE);
                    imageView_GSM_medium.setVisibility(View.INVISIBLE);
                    imageView_GSM_low.setVisibility(View.VISIBLE);
                    imageView_GSM_.setVisibility(View.INVISIBLE);
                }


                String imageView_termo = "imageView_termo_";

                if (message_text.indexOf(TERMO_NAGREV) > -1) {
                    textView_mode.setText(termostat + NAGREV);
                    imageView_termo = "imageView_termo_heater";
                    imageView_termo_off.setVisibility(View.INVISIBLE);
                    imageView_termo_heater.setVisibility(View.VISIBLE);
                    imageView_termo_cooler.setVisibility(View.INVISIBLE);
                    imageView_termo_.setVisibility(View.INVISIBLE);

                }

                if (message_text.indexOf(TERMO_HOLOD) > -1) {
                    textView_mode.setText(termostat + HOLOD);
                    imageView_termo = "imageView_termo_cooler";
                    imageView_termo_off.setVisibility(View.INVISIBLE);
                    imageView_termo_heater.setVisibility(View.INVISIBLE);
                    imageView_termo_cooler.setVisibility(View.VISIBLE);
                    imageView_termo_.setVisibility(View.INVISIBLE);

                }

                if (message_text.indexOf(TERMO_MANUAL) > -1) {
                    textView_mode.setText(termostat + MANUAL);
                    imageView_termo = "imageView_termo_off";
                    imageView_termo_off.setVisibility(View.VISIBLE);
                    imageView_termo_heater.setVisibility(View.INVISIBLE);
                    imageView_termo_cooler.setVisibility(View.INVISIBLE);
                    imageView_termo_.setVisibility(View.INVISIBLE);

                }

                if (message_text.indexOf(TEMPERATURE) > -1) {
                    textView_temperature.setText(temperature + message_text.substring(message_text.indexOf(TEMPERATURE) + TEMPERATURE.length(), message_text.indexOf(TEMPERATURE) + TEMPERATURE.length() + 4));
                }

                if (message_text.indexOf(TERMOSTAT) > -1) {
                    textView_termostat.setText(termostat + message_text.substring(message_text.indexOf(TERMOSTAT) + TERMOSTAT.length(), message_text.indexOf(TERMOSTAT) + TERMOSTAT.length() + 4));
                }

                if (message_text.indexOf(T_MIN) > -1) {
                    textView_T_min.setText(T_min + message_text.substring(message_text.indexOf(T_MIN) + T_MIN.length(), message_text.indexOf(T_MIN) + T_MIN.length() + 4));
                }

                if (message_text.indexOf(T_MAX) > -1) {
                    textView_T_max.setText(T_max + message_text.substring(message_text.indexOf(T_MAX) + T_MAX.length(), message_text.indexOf(T_MAX) + T_MAX.length() + 4));
                }


                //------------------- сохраняем данные в файл
                String query = textView_query.getText().toString();
                String power = textView_power.getText().toString();
                String rele = textView_rele.getText().toString();
                String gsm = textView_gsm.getText().toString();
                String mode = textView_mode.getText().toString();
                String temperature = textView_temperature.getText().toString();
                String termostat = textView_termostat.getText().toString();
                String T_min = textView_T_min.getText().toString();
                String T_max = textView_T_max.getText().toString();


                SharedPreferences.Editor editor = mSettings.edit();

                editor.putString(APP_PREFERENCES_QUERY, query);
                editor.putString(APP_PREFERENCES_POWER, power);
                editor.putString(APP_PREFERENCES_RELE, rele);
                editor.putString(APP_PREFERENCES_GSM, gsm);
                editor.putString(APP_PREFERENCES_MODE, mode);
                editor.putString(APP_PREFERENCES_TEMPERATURE, temperature);
                editor.putString(APP_PREFERENCES_TERMOSTAT, termostat);
                editor.putString(APP_PREFERENCES_T_MIN, T_min);
                editor.putString(APP_PREFERENCES_T_MAX, T_max);
                editor.putString(APP_PREFERENCES_IMAGE_VIEW_POWER, imageView_power);
                editor.putString(APP_PREFERENCES_IMAGE_VIEW_RELE, imageView_rele);
                editor.putString(APP_PREFERENCES_IMAGE_VIEW_GSM, imageView_GSM);
                editor.putString(APP_PREFERENCES_IMAGE_VIEW_TERMO, imageView_termo);
                //editor.apply();
                editor.commit();

            } else {
                // --- не статусная смс
                //---- замена текста - латиница на кирилицу
                if (message_text.indexOf(S_220V_ON) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(S_220V_ON)) + state_220v + EST + message_text.substring(message_text.indexOf(S_220V_ON) + S_220V_ON.length(), message_text.length());

                if (message_text.indexOf(S_220V_OFF) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(S_220V_OFF)) + state_220v + NET + message_text.substring(message_text.indexOf(S_220V_OFF) + S_220V_OFF.length(), message_text.length());

                if (message_text.indexOf(PONIZHENIE_T) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(PONIZHENIE_T)) + ponizhenie_t + message_text.substring(message_text.indexOf(PONIZHENIE_T) + PONIZHENIE_T.length(), message_text.length());

                if (message_text.indexOf(PREVYSHENIE_T) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(PREVYSHENIE_T)) + prevyshenie_t + message_text.substring(message_text.indexOf(PREVYSHENIE_T) + PREVYSHENIE_T.length(), message_text.length());

                if (message_text.indexOf(VOSSTANOVLENIE_T) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(VOSSTANOVLENIE_T)) + vosstanovlenie_t + message_text.substring(message_text.indexOf(VOSSTANOVLENIE_T) + VOSSTANOVLENIE_T.length(), message_text.length());


                if (message_text.indexOf(TEMPERATURE) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(TEMPERATURE)) + temperature + message_text.substring(message_text.indexOf(TEMPERATURE) + TEMPERATURE.length(), message_text.length());

                if (message_text.indexOf(T_MIN) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(T_MIN)) + T_min + message_text.substring(message_text.indexOf(T_MIN) + T_MIN.length(), message_text.length());

                if (message_text.indexOf(TERMOSTAT) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(TERMOSTAT)) + termostat + message_text.substring(message_text.indexOf(TERMOSTAT) + TERMOSTAT.length(), message_text.length());

                if (message_text.indexOf(T_MAX) > -1)
                    message_text = message_text.substring(0, message_text.indexOf(T_MAX)) + T_max + message_text.substring(message_text.indexOf(T_MAX) + T_MAX.length(), message_text.length());


                //-------------вывод сообщения

                AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
                builder.setTitle("Cообщение от GSM-розетки!")
                        .setMessage("Время: " + msgDate + "\n" + message_text)
                        .setIcon(R.drawable.ic_launcher)
                        .setCancelable(false)
                        .setNegativeButton("ОК",
                                new DialogInterface.OnClickListener() {
                                    public void onClick(DialogInterface dialog, int id) {
                                        dialog.cancel();
                                    }
                                }
                        );
                AlertDialog alert = builder.create();
                alert.show();
            }


        }
        //---------------------------------

    }

    private String Form_T (String command) {
        if (command.length() == 0) {command="0";}
        if (command.substring(0,1).equals("-"))
        {
            command = command.replace('-', '0');
            if (command.length() < 3) {
                command = "000" + command;
            }
            command = '-' + command.substring(command.length() - 2);
        } else {
            command = command.replace('+', '0');
            if (command.length() < 3) {
                command = "000" + command;
            }
            command = command.substring(command.length() - 3);
        }
        return command;
    }
    //---try sends a SMS message ---
    private void try_sendSMS(String command) {

        String phoneNumber = PHONE_NUMBER;
        String password = PASSWORD;

        if (phoneNumber.length() > 0 && password.length() > 0)
        {
            sendSMS(phoneNumber, password + command);
        }   else {

            if (phoneNumber.length() == 0 && password.length() > 0)
                Toast.makeText(getBaseContext(),
                        Enter_Phone,
                        Toast.LENGTH_SHORT).show();
            else if (phoneNumber.length() > 0 && password.length() == 0)
                Toast.makeText(getBaseContext(),
                        Enter_Password,
                        Toast.LENGTH_SHORT).show();
            else

                Toast.makeText(getBaseContext(),
                        Enter_Phone_Password,
                        Toast.LENGTH_SHORT).show();

            // вызываем окно ввода настроек
            Intent intent = new Intent(MainActivity.this, SettingsActivity.class);
            startActivity(intent);
        }


    }


    //---sends a SMS message ---
    private void sendSMS(String phoneNumber, String message) {

        //----------------- таймер-сообщение
        AlertDialog.Builder builder = new AlertDialog.Builder(MainActivity.this);
        builder.setTitle("Выполнение команды")
                .setIcon(R.drawable.ic_launcher)
                .setMessage("Подождите пожалуйста...")
                .setCancelable(false);

        final AlertDialog dlg = builder.create();

        dlg.show();

        final Timer timer = new Timer();
        timer.schedule(new TimerTask() {
            public void run() {
                dlg.dismiss(); // when the task active then close the dialog
                timer.cancel(); // also just top the timer thread, otherwise,
                // you may receive a crash report
            }
        }, 3000); // через 3 секунд (3000 миллисекунд), the task will be active.
        //------------------------------------------



        String SENT = "COMMAND_SENT";
        String DELIVERED = "COMMAND_DELIVERED";

        PendingIntent sentPI = PendingIntent.getBroadcast(this, 0,
                new Intent(SENT), 0);

        PendingIntent deliveredPI = PendingIntent.getBroadcast(this, 0,
                new Intent(DELIVERED), 0);


        //---when the SMS has been sent---
        registerReceiver(new BroadcastReceiver() {
            @Override
            public void onReceive(Context arg0, Intent arg1) {
                switch (getResultCode()) {
                    case Activity.RESULT_OK:
                        Toast.makeText(getBaseContext(), "Команда отправлена",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case SmsManager.RESULT_ERROR_GENERIC_FAILURE:
                        Toast.makeText(getBaseContext(), "Generic failure",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case SmsManager.RESULT_ERROR_NO_SERVICE:
                        Toast.makeText(getBaseContext(), "No service",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case SmsManager.RESULT_ERROR_NULL_PDU:
                        Toast.makeText(getBaseContext(), "Null PDU",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case SmsManager.RESULT_ERROR_RADIO_OFF:
                        Toast.makeText(getBaseContext(), "Radio off",
                                Toast.LENGTH_SHORT).show();
                        break;
                }
            }
        }, new IntentFilter(SENT));


        //---when the SMS has been delivered---
        registerReceiver(new BroadcastReceiver() {
            @Override
            public void onReceive(Context arg0, Intent arg1) {
                switch (getResultCode()) {
                    case Activity.RESULT_OK:
                        Toast.makeText(getBaseContext(), "Команда доставлена",
                                Toast.LENGTH_SHORT).show();
                        break;
                    case Activity.RESULT_CANCELED:
                        Toast.makeText(getBaseContext(), "Команда не доставлена",
                                Toast.LENGTH_SHORT).show();
                        break;
                }
            }
        }, new IntentFilter(DELIVERED));


        SmsManager sms = SmsManager.getDefault();
        sms.sendTextMessage(phoneNumber, null, message, sentPI, deliveredPI);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {

        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }


    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();
        if (id == R.id.menu_about) {
            Intent intent = new Intent(MainActivity.this, AboutActivity.class);
            startActivity(intent);
            return true;
        }

        if (id == R.id.menu_settings) {
            Intent intent = new Intent(MainActivity.this, SettingsActivity.class);
            startActivity(intent);
            return true;
        }

        return super.onOptionsItemSelected(item);


    }




}