package oko.tm.gsm_socket;


import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.telephony.SmsMessage;
import android.widget.Toast;




public class SmsReceiver extends BroadcastReceiver
{

    // это будет именем файла настроек
    public static final String APP_PREFERENCES = "gsm_socket_settings";

    public static final String APP_PREFERENCES_PHONE = "phone";
    public String PHONE_NUMBER = "";
    public int PHONE_NUMBER_TAIL=9;

    @Override
    public void onReceive(Context context, Intent intent)
    {
        //----------- работа с файлом, содержащий настройки
        SharedPreferences mSettings = context.getSharedPreferences(APP_PREFERENCES,
                Context.MODE_PRIVATE);


        //------------ вычитываем телефонный номер GSM-розетки
        if(mSettings.contains(APP_PREFERENCES_PHONE)) {
            PHONE_NUMBER=mSettings.getString(APP_PREFERENCES_PHONE, "");
        }

        //---get the SMS message passed in---
        Bundle bundle = intent.getExtras();
        SmsMessage[] msgs = null;
        String str = "", message_from="", message_text="", phone1="", phone2="";
        if (bundle != null)
        {
            //---retrieve the SMS message received---
            Object[] pdus = (Object[]) bundle.get("pdus");
            msgs = new SmsMessage[pdus.length];
            for (int i=0; i<msgs.length; i++)
            {
                msgs[i] = SmsMessage.createFromPdu((byte[])pdus[i]);
                message_from += msgs[i].getOriginatingAddress();
                message_text += msgs[i].getMessageBody().toString();
                str += "Входящая SMS от " + msgs[i].getOriginatingAddress();
                str += " :\n";
                str += msgs[i].getMessageBody().toString();
                str += "\n";
            }

            phone1=PHONE_NUMBER;
            phone2=message_from;
            // ----- сравниеваем номер входной смс с номером GSM-розетки - сравниваем "хвост"
            if (PHONE_NUMBER.length()>PHONE_NUMBER_TAIL) {
                phone1=PHONE_NUMBER.substring(PHONE_NUMBER.length()-PHONE_NUMBER_TAIL).toString();

                if (message_from.length()>PHONE_NUMBER_TAIL)
                    phone2=message_from.substring(message_from.length()-PHONE_NUMBER_TAIL);
            }

            if (phone1.equals(phone2))
            {

                //---display the new SMS message---
                Toast.makeText(context, str, Toast.LENGTH_SHORT).show();


                //--- перезапускаем приложение
                Intent startActivity = new Intent();
                startActivity.setClass(context, MainActivity.class);
                startActivity.setAction(MainActivity.class.getName());
                startActivity.setFlags(
                        Intent.FLAG_ACTIVITY_NEW_TASK

                        | Intent.FLAG_ACTIVITY_CLEAR_TOP

                );
                startActivity.putExtra("message", message_text);
                startActivity.putExtra("sender", message_from);
                context.startActivity(startActivity);



            } else {



            }


        }
    }
}